// ----------------------------------------------
//  RS232 
// ----------------------------------------------

#include <device.h>
#include <rs_232.h>

unsigned char s_rbuf[RS_RSIZE]; //  
unsigned char s_sbuf[RS_SSIZE]; //  

bit f_send;          //  
unsigned char s_rb;  //  
// ----------------------------------------------
// 

bit s_rok;           //   ,    
bit s_resc;          //    
unsigned char s_rcs; //  
unsigned char s_ri;  //  
// ----------------------------------------------
// 

bit s_sok;           //    ,    
unsigned char s_scs; //  
unsigned char s_si;  //  
unsigned char s_size;  //  
// ------------------------------------------------------------
//  

void init_rs232(void)
{
  s_rok  = 0;
  s_resc = 0;
  s_rcs  = 0;
  s_ri   = 0;

  s_sok  = 0;
  s_scs  = 0;
  s_si   = 0;
  s_size = 0;
       
} // init_rs232
// ----------------------------------------------

int_rs232 () interrupt 4
{
 if(RI==1){
   s_rb = SBUF;

   if(s_rb==0x0D){
     if(s_rcs == 0){
        s_rok = 1;
        REN = 0;
     }
     s_ri = 0;
     s_rcs = 0;
   }
   else{
     if(s_rb==0x40){
       s_resc = 1;
     }
     else{
       if(s_resc==1){
         if(s_rb==0x00){s_rb = 0x40;}
         if(s_rb==0xCD){s_rb = 0x0D;}
         s_resc = 0;
       }
       s_rbuf[s_ri] = s_rb;
           s_rcs = s_rcs + s_rb;
       if(s_ri<(RS_RSIZE -1)) s_ri++;
     }
   }
  RI = 0;
  
 }
 else
 {
   if(s_si<s_size){ //     
      SBUF = s_sbuf[s_si];
      s_si++;
   }
  TI = 0;
  f_send = 1;
 }
}
// ----------------------------------------------

void rs_sb(unsigned char sb)
{
//  unsigned int i;
//  REN = 0;  //   
  SBUF = sb;
  f_send = 0; 
  s_scs = s_scs - sb;
  while(f_send==0){} //
//  for(i=0;i<20000;i++){} //    
  
//  REN = 1; //   
}
// ----------------------------------------------

void rs_begin(void)
{
  s_scs = 0;
  s_size = 0;
  s_si = 0;
}
// ----------------------------------------------

void rs_send(unsigned char b)
{
 if(b==0x0D){
   rs_sb(0x40);
   rs_sb(0xCD);
 }
 else
 {
   if(b==0x40){
     rs_sb(0x40);
     rs_sb(0x00);
   }
   else
   {
     rs_sb(b);
   }
 }
}
// ----------------------------------------------

void rs_end(void)
{
   rs_send(s_scs);
   rs_sb(0x0D);
}
// -----------------------------------------------------------
//   
// -----------------------------------------------------------

void sb_begin(void) //    
{
  s_scs = 0;
  s_si  = 0;
//  s_sok = 0;
  s_size = 0;
}
// ----------------------------------------------

void sb_end(void) //    
{
  sb_write(s_scs);
  s_sbuf[s_size] = 0x0D;
  s_size++;
  s_si = 1;
  SBUF = s_sbuf[0];
//  s_sok = 1;
}
// ----------------------------------------------

void sb_write(unsigned char wb) //   
{
  s_scs = s_scs - wb;
   if(wb==0x0D){
      s_sbuf[s_size] = 0x40;  s_size++;
      s_sbuf[s_size] = 0xCD;  s_size++;
   }
   else{
      if(wb==0x40){
         s_sbuf[s_size] = 0x40;  s_size++;
         s_sbuf[s_size] = 0x00;  s_size++;
      }
      else{
         s_sbuf[s_size] = wb;  s_size++;
      }
   }
} // sb_write
// ----------------------------------------------
void sb_wbuf(unsigned char *p, unsigned char count)
{
  unsigned char *pch;
  unsigned char i;

   pch = p;

   for(i=0;i<count;i++){
       sb_write(*pch);
       pch++;
   }
}
// ----------------------------------------------
void sb_send(void) //    RS-232
{
   unsigned char sb;

  s_si = 0;
  do{
     sb = s_sbuf[s_si];
     rs_sb(sb);
     s_si++;
  }while( sb != 0x0D);
}
// ----------------------------------------------